#ifndef adc12_h
#define adc12_h

#include "types.h"

#define ADC12_FULL_SCALE    0x0fff      // 12-bit ADC
#define ADC12_VREF          2.5         // 2.5V internal reference
#define ADC12_NCH           3           // number of channels to measure

void ADC12Init (void);                  // initialize the ADC
void ADC12avg (void);                   // calc average from over-sampled data
float ADC12ChV (uchar ch);              // return current channel voltage
float Tcase (void);                     // case temperature (C)
float Tair (void);                      // air temperature (C)
float Flow (void);                      // std flow rate (m/s)

#endif
