#ifndef CRC_H
#define CRC_H

#include "global.h"

// Calculate 16-bit CCITT CRC using 0x1021 polynomial
// If the CRC is located at the end of the packet (MSB first),
// and the packet is good, then the CRC returns 0 if ok
uint calc_crc (char *pkt, uint length);

// Calculate 16-bit CCITT CRC using 0x1021 polynomial
// places the CRC in the last 2 bytes of the packet, MSB first
void update_crc (char *pkt, uint length);

#endif
