#include "dac12.h"
#include "global.h"

// initialize the DAC
// relies on ADC12 having the internal 2.5V reference turned on
// 1x input range
// medium speed/current
void DAC12Init (void)
{
    DAC12_0CTL = DAC12LSEL_0 | DAC12IR | DAC12AMP_2;
    DAC12_0CTL |= DAC12CALON;                       // start offset cal
    while (!(DAC12_0CTL && DAC12CALON)) {}          // wait for cal to complete
    DAC12_0DAT = 1;                                 // enable output
}


// set DAC output (V)
void DAC12set (float v)
{
    DAC12_0DAT = (uint)((float)DAC12_FS * v / DAC12_VREF);
}

