#ifndef flash_h
#define flash_h

#include "types.h"

// for MSP430F2418
#define INFO_SEGMENT_SIZE   0x40
#define INFO_SEGMENT_CNT    4
#define SEGMENT_SIZE        0x0200
#define SEGMENT_CNT         0xe6
#define TOP_OF_FLASH        0x1ffff

// information segments, 64 bytes each (0x40)
#define SEGMENT_A           0x10C0
#define SEGMENT_B           0x1080
#define SEGMENT_C           0x1040
#define SEGMENT_D           0x1000

// main flash memory, 512 bytes each (0x0200)
#define SEGMENT_000         0x1FE00
#define SEGMENT_001         0x1FC00
#define SEGMENT_002         0x1FA00
#define SEGMENT_003         0x1F800
#define SEGMENT_004         0x1F600
#define SEGMENT_005         0x1F400
#define SEGMENT_006         0x1F200
#define SEGMENT_007         0x1F000
#define SEGMENT_008         0x1EE00
#define SEGMENT_009         0x1EC00
#define SEGMENT_00A         0x1EA00
#define SEGMENT_00B         0x1E800
#define SEGMENT_00C         0x1E600
#define SEGMENT_00D         0x1E400
#define SEGMENT_00E         0x1E200
#define SEGMENT_00F         0x1E000
#define SEGMENT_010         0x1DE00
// ...
#define SEGMENT_080         0x0FE00         // reserved for interrupt vectors
#define SEGMENT_081         0x0FC00
// ...
#define SEGMENT_0E6         0x03200

// all functions return 0 if ok, non zero if error
int RdInfoFlash(char* data, uint size);
int RdFlash(char* data, ulong segment, uint size);
int WrInfoFlash(char* data, uint size);
int WrFlash(char* data, ulong segment, uint size);

#endif
