#ifndef sio_h
#define sio_h

#include "types.h"

#define MSG_TX_QUEUE_SIZE 500       // transmit queue size
#define MSG_RX_QUEUE_SIZE 100       // receive queue size


// initalize receive and transmit queues
void SIOinit (uint baudrate);

// send a single char
// blocking routine - will not return until char has been placed in queue
void SIOtxChar (char c);

// send a string
// blocking routine - will not return until string has been placed in queue
void SIOtxStr (char* str);

// send a string, CRLF automatically added
// blocking routine - will not return until string has been placed in queue
void SIOtxMsg (char* msg);

// return true if a message is available in the queue
bool SIOmsgAvail (void);

// process a single message if available in the receive queue
// return is non-zero if a message was processed and returning info in "msg"
uchar SIOprocMsg (char msg[]);

// clear (empty) the receive queue
void SIOclrRxQ (void);

#endif
