#include "xadc.h"


// read xADC data
void Rd_xADC (long int d[]) {
        int     i;
        uchar   in;

        xADC_POUT &= ~xADC_DCLK;                    // setup dclk = 0
        xADC_POUT &= ~xADC_DXMIT;                   // start xADC xmit process (-_)
        for (i=0;i<N_FILTER;i++) {                  // init data
            d[i] = 0;
        }
        // get input 2 (MSB first)
        xADC_POUT |= xADC_DCLK;                         // _-
        in = xADC_DATA_PIN;                             // get input 2 data, MSB first, 1st bit
        d[8] = in & 0x01;                               // get input 2 data, MSB first, 1st bit
        in = in >> 1;
        d[6] = in & 0x01;
        in = in >> 1;
        d[4] = in & 0x01;
        in = in >> 1;
        d[2] = in & 0x01;
        in = in >> 1;
        d[0] = in & 0x01;
        for (i=0;i<N_BITS-1;i++) {                      // get the rest of the bits
            xADC_POUT &= ~xADC_DCLK;                    // -_
            d[8] = d[8] << 1;                           // prepare for next bit
            d[6] = d[6] << 1;
            d[4] = d[4] << 1;
            d[2] = d[2] << 1;
            d[0] = d[0] << 1;
            xADC_POUT |= xADC_DCLK;                     // _-
            in = xADC_DATA_PIN;                         // get input 2 data, MSB first, 1st bit
            d[8] |= in & 0x01;                          // get input 2 data, MSB first, 1st bit
            in = in >> 1;
            d[6] |= in & 0x01;
            in = in >> 1;
            d[4] |= in & 0x01;
            in = in >> 1;
            d[2] |= in & 0x01;
            in = in >> 1;
            d[0] |= in & 0x01;
        }
        // get input 1 (MSB first)
        for (i=0;i<N_BITS;i++) {                        // get all of intput 1 bits
            xADC_POUT &= ~xADC_DCLK;                    // -_
            d[9] = d[9] << 1;                           // prepare for next bit
            d[7] = d[7] << 1;
            d[5] = d[5] << 1;
            d[3] = d[3] << 1;
            d[1] = d[1] << 1;
            xADC_POUT |= xADC_DCLK;                     // _-
            in = xADC_DATA_PIN;                         // get input 2 data, MSB first, 1st bit
            d[9] |= in & 0x01;                          // get input 2 data, MSB first, 1st bit
            in = in >> 1;
            d[7] |= in & 0x01;
            in = in >> 1;
            d[5] |= in & 0x01;
            in = in >> 1;
            d[3] |= in & 0x01;
            in = in >> 1;
            d[1] |= in & 0x01;
        }
        xADC_POUT &= ~xADC_DCLK;                    // leave dclk low (-_)
        xADC_POUT |= xADC_DXMIT;                    // finished with xADC xmit (_-)
        for (i=0;i<N_FILTER;i++) {                  // remove offset in ADC output
            d[i] -= 0x01000;
        }
}
