#ifndef xADC_H
#define xADC_H

#include "types.h"
#include "global.h"

// detector external ADCs
#define xADC_POUT       P1OUT
#define xADC_PIN        P1IN
#define xADC_CONV       0x08                        // xADC CONV ouput (sync'd with clk using D-FF), PORT1.3
#define xADC_DXMIT      0x04                        // xADC -Dxmit ouput, PORT1.2
#define xADC_DVALID     0x02                        // xADC -Dvalid input, PORT1.1
#define xADC_DCLK       0x01                        // xADC Dclk ouput, PORT1.0
// SMCLK (P1.3) = clk for xADCs (10.00 MHz)
#define xADC_DATA_PIN   P2IN
#define xADC_DOUT1      0x10                        // xADC data output, PORT2.4
#define xADC_DOUT2      0x08                        // xADC data output, PORT2.3
#define xADC_DOUT3      0x04                        // xADC data output, PORT2.2
#define xADC_DOUT4      0x02                        // xADC data output, PORT2.1
#define xADC_DOUT5      0x01                        // xADC data output, PORT2.0

#define N_BITS          20                          // number of bits in the result from the ADC

void Rd_xADC (long int d[]);                        // read xADC data

#endif
